<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/datatype.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/datatype.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PL_DATATYPE__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_DATATYPE__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scfstr_8h.html">csutil/scfstr.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scfarray_8h.html">csutil/scfarray.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector2_8h.html">csgeom/vector2.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector3_8h.html">csgeom/vector3.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector4_8h.html">csgeom/vector4.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cscolor_8h.html">csutil/cscolor.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>;
<a name="l00032"></a>00032 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00033"></a>00033 
<a name="l00038"></a>00038 <span class="keyword">enum</span> celDataType
<a name="l00039"></a>00039 {
<a name="l00041"></a>00041   CEL_DATA_NONE = 0,
<a name="l00043"></a>00043   CEL_DATA_BOOL,
<a name="l00045"></a>00045   CEL_DATA_BYTE,
<a name="l00047"></a>00047   CEL_DATA_WORD,
<a name="l00049"></a>00049   CEL_DATA_LONG,
<a name="l00051"></a>00051   CEL_DATA_UBYTE,
<a name="l00053"></a>00053   CEL_DATA_UWORD,
<a name="l00055"></a>00055   CEL_DATA_ULONG,
<a name="l00057"></a>00057   CEL_DATA_FLOAT,
<a name="l00059"></a>00059   CEL_DATA_VECTOR2,
<a name="l00061"></a>00061   CEL_DATA_VECTOR3,
<a name="l00063"></a>00063   CEL_DATA_VECTOR4,
<a name="l00065"></a>00065   CEL_DATA_STRING,
<a name="l00067"></a>00067   CEL_DATA_PCLASS,
<a name="l00069"></a>00069   CEL_DATA_ENTITY,
<a name="l00071"></a>00071   CEL_DATA_ACTION,
<a name="l00073"></a>00073   CEL_DATA_COLOR,
<a name="l00075"></a>00075   CEL_DATA_COLOR4,
<a name="l00077"></a>00077   CEL_DATA_IBASE,
<a name="l00079"></a>00079   CEL_DATA_PARAMETER,
<a name="l00081"></a>00081   CEL_DATA_LAST
<a name="l00082"></a>00082 };
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="structcelData.html">00087</a> <span class="keyword">struct </span><a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   celDataType type;
<a name="l00090"></a>00090   <span class="keyword">union</span>
<a name="l00091"></a>00091   {
<a name="l00092"></a>00092     <span class="keywordtype">bool</span> bo;
<a name="l00093"></a>00093     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa79c2d3de4fcd200458c406f40b2ae64">int8</a> b;
<a name="l00094"></a>00094     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> ub;
<a name="l00095"></a>00095     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa0d0fdc87fd135ef2bedb030901cdb9c">int16</a> w;
<a name="l00096"></a>00096     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a> uw;
<a name="l00097"></a>00097     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gab7903878916593daecbeb95b98115ab0">int32</a> l;
<a name="l00098"></a>00098     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> ul;
<a name="l00099"></a>00099     <span class="keywordtype">float</span> f;
<a name="l00100"></a>00100     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiString.html">iString</a>* s;
<a name="l00101"></a>00101     <span class="keyword">struct</span>
<a name="l00102"></a>00102     {
<a name="l00103"></a>00103       <span class="keywordtype">float</span> x, y, z, w;
<a name="l00104"></a>00104     } v;
<a name="l00105"></a>00105     <span class="keyword">struct</span>
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107       <span class="keywordtype">float</span> red, green, blue, alpha;
<a name="l00108"></a>00108     } col;
<a name="l00109"></a>00109     <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc;
<a name="l00110"></a>00110     <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* ent;
<a name="l00111"></a>00111     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* ibase;
<a name="l00112"></a>00112     <span class="keyword">struct</span>
<a name="l00113"></a>00113     {
<a name="l00114"></a>00114       <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiString.html">iString</a>* parname;
<a name="l00115"></a>00115       celDataType partype;
<a name="l00116"></a>00116     } par;
<a name="l00117"></a>00117   } value;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> () : type (CEL_DATA_NONE) { }
<a name="l00120"></a>00120   <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> (<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; copy)
<a name="l00121"></a>00121   {
<a name="l00122"></a>00122     type = copy.type;
<a name="l00123"></a>00123     value = copy.value;
<a name="l00124"></a>00124     <span class="keywordflow">if</span> (type == CEL_DATA_STRING || type == CEL_DATA_ACTION) value.s-&gt;IncRef ();
<a name="l00125"></a>00125     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == CEL_DATA_PARAMETER) value.par.parname-&gt;IncRef ();
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127   <span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; copy)
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     Clear ();
<a name="l00130"></a>00130     type = copy.type;
<a name="l00131"></a>00131     value = copy.value;
<a name="l00132"></a>00132     <span class="keywordflow">if</span> (type == CEL_DATA_STRING || type == CEL_DATA_ACTION) value.s-&gt;IncRef ();
<a name="l00133"></a>00133     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == CEL_DATA_PARAMETER) value.par.parname-&gt;IncRef ();
<a name="l00134"></a>00134     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136   ~<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>()
<a name="l00137"></a>00137   {
<a name="l00138"></a>00138     Clear ();
<a name="l00139"></a>00139   }
<a name="l00140"></a>00140   <span class="keywordtype">void</span> Clear ()
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142     <span class="keywordflow">if</span> (type == CEL_DATA_STRING || type == CEL_DATA_ACTION) value.s-&gt;DecRef ();
<a name="l00143"></a>00143     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == CEL_DATA_PARAMETER) value.par.parname-&gt;DecRef ();
<a name="l00144"></a>00144     type = CEL_DATA_NONE;
<a name="l00145"></a>00145   }
<a name="l00149"></a><a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed">00149</a>   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keywordtype">bool</span> v) { Clear (); type = CEL_DATA_BOOL; value.bo = v; }
<a name="l00150"></a>00150   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa79c2d3de4fcd200458c406f40b2ae64">int8</a> v) { Clear (); type = CEL_DATA_BYTE; value.b = v; }
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> v) { Clear (); type = CEL_DATA_UBYTE; value.ub = v; }
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa0d0fdc87fd135ef2bedb030901cdb9c">int16</a> v) { Clear (); type = CEL_DATA_WORD; value.w = v; }
<a name="l00153"></a>00153   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a> v) { Clear (); type = CEL_DATA_UWORD; value.uw = v; }
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gab7903878916593daecbeb95b98115ab0">int32</a> v) { Clear (); type = CEL_DATA_LONG; value.l = v; }
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> v) { Clear (); type = CEL_DATA_ULONG; value.ul = v; }
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keywordtype">float</span> v) { Clear (); type = CEL_DATA_FLOAT; value.f = v; }
<a name="l00157"></a>00157   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp; v)
<a name="l00158"></a>00158   {
<a name="l00159"></a>00159     Clear ();
<a name="l00160"></a>00160     type = CEL_DATA_VECTOR2;
<a name="l00161"></a>00161     value.v.x = v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html#acf4ee25489c98e6b7b7a460c4edd4ac6">x</a>;
<a name="l00162"></a>00162     value.v.y = v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html#af736730a67b9ee807f1455da3d2be188">y</a>;
<a name="l00163"></a>00163   }
<a name="l00164"></a>00164   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; v)
<a name="l00165"></a>00165   {
<a name="l00166"></a>00166     Clear ();
<a name="l00167"></a>00167     type = CEL_DATA_VECTOR3;
<a name="l00168"></a>00168     value.v.x = v.x;
<a name="l00169"></a>00169     value.v.y = v.y;
<a name="l00170"></a>00170     value.v.z = v.z;
<a name="l00171"></a>00171   }
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector4.html">csVector4</a>&amp; v)
<a name="l00173"></a>00173   {
<a name="l00174"></a>00174     Clear ();
<a name="l00175"></a>00175     type = CEL_DATA_VECTOR4;
<a name="l00176"></a>00176     value.v.x = v.x;
<a name="l00177"></a>00177     value.v.y = v.y;
<a name="l00178"></a>00178     value.v.z = v.z;
<a name="l00179"></a>00179     value.v.w = v.w;
<a name="l00180"></a>00180   }
<a name="l00181"></a>00181   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp; v)
<a name="l00182"></a>00182   {
<a name="l00183"></a>00183     Clear ();
<a name="l00184"></a>00184     type = CEL_DATA_COLOR;
<a name="l00185"></a>00185     value.col.red = v.red;
<a name="l00186"></a>00186     value.col.green = v.green;
<a name="l00187"></a>00187     value.col.blue = v.blue;
<a name="l00188"></a>00188   }
<a name="l00189"></a>00189   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor4.html">csColor4</a>&amp; v)
<a name="l00190"></a>00190   {
<a name="l00191"></a>00191     Clear ();
<a name="l00192"></a>00192     type = CEL_DATA_COLOR4;
<a name="l00193"></a>00193     value.col.red = v.red;
<a name="l00194"></a>00194     value.col.green = v.green;
<a name="l00195"></a>00195     value.col.blue = v.blue;
<a name="l00196"></a>00196     value.col.alpha = v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor4.html#abdeac21fd389f0b5ec8d19cd4bb19c53">alpha</a>;
<a name="l00197"></a>00197   }
<a name="l00198"></a>00198   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* s)
<a name="l00199"></a>00199   {
<a name="l00200"></a>00200     Clear ();
<a name="l00201"></a>00201     type = CEL_DATA_STRING;
<a name="l00202"></a>00202     value.s = <span class="keyword">new</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfString.html">scfString</a> (s);
<a name="l00203"></a>00203   }
<a name="l00204"></a>00204   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc)
<a name="l00205"></a>00205   {
<a name="l00206"></a>00206     Clear ();
<a name="l00207"></a>00207     type = CEL_DATA_PCLASS;
<a name="l00208"></a>00208     value.pc = pc;
<a name="l00209"></a>00209   }
<a name="l00210"></a>00210   <span class="keywordtype">void</span> <a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* ent)
<a name="l00211"></a>00211   {
<a name="l00212"></a>00212     Clear ();
<a name="l00213"></a>00213     type = CEL_DATA_ENTITY;
<a name="l00214"></a>00214     value.ent = ent;
<a name="l00215"></a>00215   }
<a name="l00216"></a>00216   <span class="keywordtype">void</span> SetAction (<span class="keyword">const</span> <span class="keywordtype">char</span>* s)
<a name="l00217"></a>00217   {
<a name="l00218"></a>00218     Clear ();
<a name="l00219"></a>00219     type = CEL_DATA_ACTION;
<a name="l00220"></a>00220     value.s = <span class="keyword">new</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfString.html">scfString</a> (s);
<a name="l00221"></a>00221   }
<a name="l00222"></a>00222   <span class="keywordtype">void</span> SetIBase (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* b)
<a name="l00223"></a>00223   {
<a name="l00224"></a>00224     Clear ();
<a name="l00225"></a>00225     type = CEL_DATA_IBASE;
<a name="l00226"></a>00226     value.ibase = b;
<a name="l00227"></a>00227   }
<a name="l00228"></a>00228   <span class="keywordtype">void</span> SetParameter (<span class="keyword">const</span> <span class="keywordtype">char</span>* s, celDataType t)
<a name="l00229"></a>00229   {
<a name="l00230"></a>00230     Clear ();
<a name="l00231"></a>00231     type = CEL_DATA_PARAMETER;
<a name="l00232"></a>00232     value.par.parname = <span class="keyword">new</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfString.html">scfString</a> (s);
<a name="l00233"></a>00233     value.par.partype = t;
<a name="l00234"></a>00234   }
<a name="l00235"></a>00235   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> GetDebugInfo ();
<a name="l00236"></a>00236 };
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="keyword">struct </span>iCelDataArrayReadOnly : <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiArrayReadOnly.html">iArrayReadOnly</a>&lt;celData&gt;
<a name="l00239"></a>00239 {
<a name="l00240"></a>00240   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util__containers.html#gaa2a21a3662510de90ca7dad0bf002734">SCF_IARRAYREADONLY_INTERFACE</a>(iCelDataArrayReadOnly);
<a name="l00241"></a>00241 };
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="keyword">struct </span>iCelDataArray : <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiArrayChangeAll.html">iArrayChangeAll</a>&lt;celData&gt;
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util__containers.html#ga4ea191f7c63ce4d230d82d181b801f61">SCF_IARRAYCHANGEALL_INTERFACE</a>(iCelDataArrayReadOnly);
<a name="l00246"></a>00246 };
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#endif // __CEL_PL_DATATYPE__</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
